﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace InsideLinq
{
    class Program
    {
        static void Main(string[] args)
        {
            Test1();
            //TestEnumerable();
            //TestQueryExpressionTrees();
    
            Console.WriteLine("Press any key to continue");
            Console.Read();
        }

        static void Test1()
        {
            QueryableString value = new QueryableString("this is a test");
            Func<char, bool> filter = new Func<char, bool>(IsChar);
            Func<char, char> selector = new Func<char, char>(SelfSelector);
            
            IEnumerable<char> FluentQuery = value
                                            .Where(input => input != ' ')
                                            .Select(input => input)
                                            .Distinct();

            QueryableString.PrintValues(FluentQuery, "T1 Found char: {0}");
           
            #region ExtensionMethods
            var query =
                  QueryableString.Distinct<char>(
                      QueryableString.Select(
                          QueryableString.Where(
                              new QueryableString("This is a test"),
                              filter),
                           selector)
                       );

            QueryableString.PrintValues(query, "Found with Static Merhods: {0}");
            #endregion
            #region Query Comprehensions

            IEnumerable<char> query2 = from c in value
                                       where c != ' '
                                       orderby c
                                       select c;

            QueryableString.PrintValues(query2.Distinct(), "T1 Found char as query comprehension: {0}");
            #endregion
        }

        static bool IsChar(char input)
        {
            return (input != ' ');
        }

        static char SelfSelector(char input)
        {
            return input;
        }

        static void TestEnumerable()
        {
            QueryableString value = new QueryableString("This is a test");
            foreach (char enumValue in value)
            {
                Console.Write("{0}-", enumValue);
            }
            Console.WriteLine();
        }

        private static void TestQueryExpressionTrees()
        {
            var query = new QueryableString("This is a test").WhereExpression(testChar => testChar == 's');

            query.PrintValues("ExpressionTree char: {0}");
        }
    }
}
